/**
 * @properties={typeid:35,uuid:"81D6011E-703B-43FE-9896-FC303E081012",variableType:-4}
 */
var accepted_filters = null;

/**
 * @properties={typeid:35,uuid:"D5832A83-1C2B-4785-B21F-0F892F36CEBC",variableType:-4}
 */
var actions = ["load","export","report"];

/**
 * @properties={typeid:35,uuid:"2FBFF76D-B013-4500-99CC-DF0248063B23",variableType:-4}
 */
var addingParts = {status		: "AND SKM.STATO_SCHEDA = ?",
                   type			: "AND SKA.TIPO_ANOMALIA = ?",
                   subtype		: "AND SKA.SOTTOTIPO_ANOMALIA = ?",
                   def_reason	: "AND SKA.ATTRIBUZIONE = ?",
                   mod_reason	: "AND SKM.CAUSALE_MODIFICA = ?"};

/**
 * @properties={typeid:35,uuid:"CBCC755F-F898-40D1-8D5C-95C3353FA730",variableType:-4}
 */
var args = null;

/**
 * @properties={typeid:35,uuid:"E6D37C3B-3704-4413-8545-69ECE6717E0C",variableType:-4}
 */
var container = null;

/**
 * @properties={typeid:35,uuid:"EC487A89-324C-4683-8DD6-7AA0FB6A81B5",variableType:-4}
 */
var filters = ["mod_reason","history_flag"];

/**
 * @type {String}
 *
 * @properties={typeid:35,uuid:"1C2328B0-6BB4-499D-AAD1-EE10D7180A4F"}
 */
var query = "";

/**
 * @properties={typeid:35,uuid:"5BFDEC3F-6189-472A-8326-A980E38B0D72",variableType:-4}
 */
var query_ex = {query: null, args: null, form: null};

/**
 * @properties={typeid:35,uuid:"7274218A-6EA1-40AC-8548-0A10D70D2610",variableType:-4}
 */
var query_exGraphical = {query: null, args: null, form: null};

/**
 * @type {String}
 *
 * @properties={typeid:35,uuid:"73CE6456-3C8D-4B3C-8C00-F68D2FDF015E"}
 */
var replacePart = "(SKM.MODELLO IN **MODELS_HERE** OR SKM.VERSIONE IN **VERSIONS_HERE**)";

/**
 * @properties={typeid:35,uuid:"159106C1-F93D-46D8-AFDC-C996E7EA5761",variableType:-4}
 */
var title = null;

/**
 * Callback method when form is (re)loaded.
 *
 * @param {JSEvent} event the event that triggered the action
 *
 * @properties={typeid:24,uuid:"5A4A8852-ED0A-4FD0-819B-0DDE1C306FE0"}
 */
function onLoad(event) {
	container = forms.report_istogrammi;
	//Aggiungo il listener per il click
	
//	JStaffa
//	elements.chart.addMouseListener(container.rightClickHandler);
//	elements.chart.addMouseListener(java.awt.event.MouseListener(container.rightClickHandler));
//FS
	/** @type {java.awt.event.MouseListener} */
	var rightClickHandler=container.rightClickHandler;
	elements.chart.addMouseListener(rightClickHandler);
	//Setto le query e i parametri TRANNE il primo l'ultimo, che verranno generati dal metodo di generazione del chart
	setupInfo(true);
	title = "Schede modifica";
}

/**
 * Callback method for when form is shown.
 *
 * @param {Boolean} firstShow form is shown first time after load
 * @param {JSEvent} event the event that triggered the action
 *
 * @properties={typeid:24,uuid:"E979C752-E07F-4FD4-BC69-1C984B90C56C"}
 */
function onShowForm(firstShow, event) {
	container.selected = controller.getName();
	if(firstShow){
		container.setupChart();
	}
	container.setLocalHelpMessage(null);
	container.checkFiltersOnShow();
	container.setupFilters();
	container.drawChart();
}

/**
 * @properties={typeid:24,uuid:"8744A708-0ED0-4743-ADA5-DF7127BA4BA6"}
 */
function setupInfo(_history){
	var q_noHistory = "SELECT FILTERX_, FILTERY_, COUNT(*) COUNT_ FROM (SELECT **X_HERE** FILTERX_, 'Categoria unica' FILTERY_ FROM (SELECT SKM.STATO_SCHEDA STATUS_, SKM.GRUPPO_FUNZIONALE GROUP_, SKM.GRUPPO_FUNZIONALE || TRIM(SKM.GRUPPO_FUNZIONALE2) FULLGROUP_, TRIM(SKM.ENTE_PROPOSTA_MODIFICA) DEPARTMENT_, TRIM(SKM.LEADER) LEADER_, SKM.CAUSALE_MODIFICA MOD_REASON_, (SELECT COUNT(*) FROM K8_SEGNALAZIONI_FULL I INNER JOIN K8_SCHEDE_MODIFICA J ON I.ENTE = J.ENTE_INSERIMENTO_ANOMALIA AND I.NUMERO_SCHEDA = J.NR_SCHEDA_ANOMALIA WHERE J.K8_SCHEDE_MODIFICA_ID = SKM.K8_SCHEDE_MODIFICA_ID) HISTORY_, SKM.TIPO_APPROVAZIONE APPROVAL_ FROM K8_SCHEDE_MODIFICA SKM WHERE (SKM.MODELLO IN **MODELS_HERE** OR SKM.VERSIONE IN **VERSIONS_HERE**))) GROUP BY FILTERX_, FILTERY_ ORDER BY FILTERX_, FILTERY_";
	var q_history = "SELECT FILTERX_, FILTERY_, **VIEW_HERE** COUNT_ FROM (SELECT **X_HERE** FILTERX_, **Y_HERE** FILTERY_, FACTOR_ FROM (SELECT SKM.STATO_SCHEDA STATUS_, SKM.GRUPPO_FUNZIONALE GROUP_, SKM.GRUPPO_FUNZIONALE || TRIM(SKM.GRUPPO_FUNZIONALE2) FULLGROUP_, TRIM(SKM.ENTE_PROPOSTA_MODIFICA) DEPARTMENT_, TRIM(SKM.LEADER) LEADER_, TRIM(SKA.SEGNALATO_DA) REPORTER_, SKA.GESTIONE_ANOMALIA MANAGEMENT_, TRIM(SKA.RESPONSABILE) RESPONSIBLE_, SKM.CAUSALE_MODIFICA MOD_REASON_, (SELECT COUNT(*) FROM K8_SEGNALAZIONI_FULL I INNER JOIN K8_SCHEDE_MODIFICA J ON I.ENTE = J.ENTE_INSERIMENTO_ANOMALIA AND I.NUMERO_SCHEDA = J.NR_SCHEDA_ANOMALIA WHERE J.K8_SCHEDE_MODIFICA_ID = SKM.K8_SCHEDE_MODIFICA_ID) HISTORY_, SKM.TIPO_APPROVAZIONE APPROVAL_, TO_NUMBER(SKA.PUNTEGGIO_DEMERITO) SEVERITY_, SKA.TIPO_ANOMALIA TYPE_, SKA.TIPO_COMPONENTE TCOM_, SKA.ATTRIBUZIONE DEF_REASON_, NVL(TO_NUMBER(SKA.PUNTEGGIO_DEMERITO),0) FACTOR_ FROM K8_SEGNALAZIONI_FULL SKA INNER JOIN K8_SCHEDE_MODIFICA SKM ON SKA.ENTE = SKM.ENTE_INSERIMENTO_ANOMALIA AND SKA.NUMERO_SCHEDA = SKM.NR_SCHEDA_ANOMALIA WHERE (SKM.MODELLO IN **MODELS_HERE** OR SKM.VERSIONE IN **VERSIONS_HERE**))) GROUP BY FILTERX_, FILTERY_ ORDER BY FILTERX_, FILTERY_";
	
	var q_exNoHistory = "SELECT ID_ FROM (SELECT SKM.K8_SCHEDE_MODIFICA_ID ID_, SKM.STATO_SCHEDA STATUS_, SKM.GRUPPO_FUNZIONALE GROUP_, SKM.GRUPPO_FUNZIONALE || TRIM(SKM.GRUPPO_FUNZIONALE2) FULLGROUP_, TRIM(SKM.ENTE_PROPOSTA_MODIFICA) DEPARTMENT_, TRIM(SKM.LEADER) LEADER_, SKM.CAUSALE_MODIFICA MOD_REASON_, (SELECT COUNT(*) FROM K8_SEGNALAZIONI_FULL I INNER JOIN K8_SCHEDE_MODIFICA J ON I.ENTE = J.ENTE_INSERIMENTO_ANOMALIA AND I.NUMERO_SCHEDA = J.NR_SCHEDA_ANOMALIA WHERE J.K8_SCHEDE_MODIFICA_ID = SKM.K8_SCHEDE_MODIFICA_ID) HISTORY_, SKM.TIPO_APPROVAZIONE APPROVAL_ FROM K8_SCHEDE_MODIFICA SKM WHERE (SKM.MODELLO IN **MODELS_HERE** OR SKM.VERSIONE IN **VERSIONS_HERE**)) WHERE **X_HERE** = ?";
	var q_exHistory = "SELECT ID_ FROM (SELECT SKM.K8_SCHEDE_MODIFICA_ID ID_, SKM.STATO_SCHEDA STATUS_, SKM.GRUPPO_FUNZIONALE GROUP_, SKM.GRUPPO_FUNZIONALE || TRIM(SKM.GRUPPO_FUNZIONALE2) FULLGROUP_, TRIM(SKM.ENTE_PROPOSTA_MODIFICA) DEPARTMENT_, TRIM(SKM.LEADER) LEADER_, TRIM(SKA.SEGNALATO_DA) REPORTER_, SKA.GESTIONE_ANOMALIA MANAGEMENT_, TRIM(SKA.RESPONSABILE) RESPONSIBLE_, SKM.CAUSALE_MODIFICA MOD_REASON_, (SELECT COUNT(*) FROM K8_SEGNALAZIONI_FULL I INNER JOIN K8_SCHEDE_MODIFICA J ON I.ENTE = J.ENTE_INSERIMENTO_ANOMALIA AND I.NUMERO_SCHEDA = J.NR_SCHEDA_ANOMALIA WHERE J.K8_SCHEDE_MODIFICA_ID = SKM.K8_SCHEDE_MODIFICA_ID) HISTORY_, SKM.TIPO_APPROVAZIONE APPROVAL_, TO_NUMBER(SKA.PUNTEGGIO_DEMERITO) SEVERITY_, SKA.TIPO_ANOMALIA TYPE_, SKA.TIPO_COMPONENTE TCOM_, SKA.ATTRIBUZIONE DEF_REASON_, NVL(TO_NUMBER(SKA.PUNTEGGIO_DEMERITO),0) FACTOR_ FROM K8_SEGNALAZIONI_FULL SKA INNER JOIN K8_SCHEDE_MODIFICA SKM ON SKA.ENTE = SKM.ENTE_INSERIMENTO_ANOMALIA AND SKA.NUMERO_SCHEDA = SKM.NR_SCHEDA_ANOMALIA WHERE (SKM.MODELLO IN **MODELS_HERE** OR SKM.VERSIONE IN **VERSIONS_HERE**)) WHERE **X_HERE** = ?";
	
	var q_exGraphNoHistory = "SELECT ID_ FROM (SELECT SKM.K8_SCHEDE_MODIFICA_ID ID_, SKM.STATO_SCHEDA STATUS_, SKM.GRUPPO_FUNZIONALE GROUP_, SKM.GRUPPO_FUNZIONALE || TRIM(SKM.GRUPPO_FUNZIONALE2) FULLGROUP_, TRIM(SKM.ENTE_PROPOSTA_MODIFICA) DEPARTMENT_, TRIM(SKM.LEADER) LEADER_, SKM.CAUSALE_MODIFICA MOD_REASON_, (SELECT COUNT(*) FROM K8_SEGNALAZIONI_FULL I INNER JOIN K8_SCHEDE_MODIFICA J ON I.ENTE = J.ENTE_INSERIMENTO_ANOMALIA AND I.NUMERO_SCHEDA = J.NR_SCHEDA_ANOMALIA WHERE J.K8_SCHEDE_MODIFICA_ID = SKM.K8_SCHEDE_MODIFICA_ID) HISTORY_, SKM.TIPO_APPROVAZIONE APPROVAL_ FROM K8_SCHEDE_MODIFICA SKM WHERE (SKM.MODELLO IN **MODELS_HERE** OR SKM.VERSIONE IN **VERSIONS_HERE**)) WHERE **X_HERE** = ?";
	var q_exGraphHistory = "SELECT ID_ FROM (SELECT SKM.K8_SCHEDE_MODIFICA_ID ID_, SKM.STATO_SCHEDA STATUS_, SKM.GRUPPO_FUNZIONALE GROUP_, SKM.GRUPPO_FUNZIONALE || TRIM(SKM.GRUPPO_FUNZIONALE2) FULLGROUP_, TRIM(SKM.ENTE_PROPOSTA_MODIFICA) DEPARTMENT_, TRIM(SKM.LEADER) LEADER_, TRIM(SKA.SEGNALATO_DA) REPORTER_, SKA.GESTIONE_ANOMALIA MANAGEMENT_, TRIM(SKA.RESPONSABILE) RESPONSIBLE_, SKM.CAUSALE_MODIFICA MOD_REASON_, (SELECT COUNT(*) FROM K8_SEGNALAZIONI_FULL I INNER JOIN K8_SCHEDE_MODIFICA J ON I.ENTE = J.ENTE_INSERIMENTO_ANOMALIA AND I.NUMERO_SCHEDA = J.NR_SCHEDA_ANOMALIA WHERE J.K8_SCHEDE_MODIFICA_ID = SKM.K8_SCHEDE_MODIFICA_ID) HISTORY_, SKM.TIPO_APPROVAZIONE APPROVAL_, TO_NUMBER(SKA.PUNTEGGIO_DEMERITO) SEVERITY_, SKA.TIPO_ANOMALIA TYPE_, SKA.TIPO_COMPONENTE TCOM_, SKA.ATTRIBUZIONE DEF_REASON_, NVL(TO_NUMBER(SKA.PUNTEGGIO_DEMERITO),0) FACTOR_ FROM K8_SEGNALAZIONI_FULL SKA INNER JOIN K8_SCHEDE_MODIFICA SKM ON SKA.ENTE = SKM.ENTE_INSERIMENTO_ANOMALIA AND SKA.NUMERO_SCHEDA = SKM.NR_SCHEDA_ANOMALIA WHERE (SKM.MODELLO IN **MODELS_HERE** OR SKM.VERSIONE IN **VERSIONS_HERE**)) WHERE **X_HERE** = ? AND **Y_HERE** = ?";
	
	if(!_history){
		query = q_noHistory;
		query_ex.query = q_exNoHistory;
		query_exGraphical.query = q_exGraphNoHistory;
		accepted_filters = [0,1,2,3,4,8,9,10];
	}else{
		query = q_history;
		query_ex.query = q_exHistory;
		query_exGraphical.query = q_exGraphHistory;
		accepted_filters = [0,1,2,3,4,5,6,7,8,9,10,11,12];
	}
	args = [];
	query_ex.args = [];
	query_ex.form = forms.schede_modifica_record.controller.getName();
	query_exGraphical.args = [];
	query_exGraphical.form = forms.schede_modifica_record.controller.getName();
}
